#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Jun 27 16:51:23 2017

@author: thiago
"""

from treeview import mostra_arvores
from arvores import NoArvore, NoArvoreBinaria   
from arvoresavl import NoArvoreAVL
    
def gera_arvores():
    print("Testando Árvores genéricas")
    yield NoArvore("A")
    yield NoArvore("A",[
        NoArvore("B"),
        NoArvore("C",[
            NoArvore("F",[NoArvore("G")])
        ]),
        NoArvore("D"),
        None,
        NoArvore("E")
    ])
    yield NoArvore("A", [
        NoArvore("B", [
            NoArvore("F"), NoArvore("G")
        ]),
        NoArvore("C"),
        NoArvore("D", [
            NoArvore("H")
        ]),
        NoArvore("E",[
            NoArvore("I"),
            NoArvore("J",[
                NoArvore("K")
            ])
        ])
    ])
    print("Testando Árvores Binárias")
    arvore = NoArvoreBinaria.ArvoreVazia
    yield arvore
    arvore = arvore.insere(8)
    yield arvore  
    arvore = arvore.insere(4)
    yield arvore  
    arvore = arvore.insere(12)
    yield arvore  
    arvore = arvore.insere(2)
    yield arvore  
    arvore = arvore.insere(6)
    yield arvore  
    arvore = arvore.insere(10)
    yield arvore  
    arvore = arvore.insere(14)
    yield arvore  
    arvore = arvore.insere(1)
    yield arvore  
    arvore = arvore.insere(3)
    yield arvore  
    arvore = arvore.insere(5)
    arvore = arvore.insere(7)
    arvore = arvore.insere(9)
    arvore = arvore.insere(11)
    yield arvore  
    arvore = arvore.remove(4)    
    yield arvore    
    arvore = arvore.remove(8)
    yield arvore
    arvore = arvore.remove(2)
    yield arvore 
    print("Testando árvore AVL")
    arvore = NoArvoreAVL.ArvoreVazia
    yield arvore
    arvore = arvore.insere(1)
    yield arvore  
    arvore = arvore.insere(3)
    yield arvore  
    arvore = arvore.insere(2)
    yield arvore  
    arvore = arvore.insere(5)
    yield arvore  
    arvore = arvore.insere(6)
    yield arvore  
    arvore = arvore.insere(7)
    yield arvore  
    arvore = arvore.insere(4)
    yield arvore  
    arvore = arvore.insere(8)
    yield arvore 
    arvore = arvore.remove(1)
    yield arvore 
    arvore = arvore.remove(2)
    yield arvore 
    arvore = arvore.remove(3)
    yield arvore 
    arvore = arvore.remove(4)
    yield arvore 

if __name__ == "__main__":
    mostra_arvores(gera_arvores())